/* gl_tex2.c */
/*TODAY IS 2/27/01
/* George Stetten and Vikram Chib */
/* adapted from SGI demo gl_tex.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <glut.h>
#include <vl/vl.h>    


#define TEXT_SIZE_X 1024
#define TEXT_SIZE_Y 512


FILE *fpt1;
FILE *fpt2;
FILE *fpt3;
FILE *fpt4;

/**************VIDEO VARIABLES**********************/
VLServer	svr;		/* Video Server */
VLPath		path;		/* Path from camera to mem */
VLNode		src, drn;	/* Nodes, camera and memory buffer */
VLControlValue	val;		/* Video controller information */
VLBuffer	buffer;		/* Video frame buffer */
VLInfoPtr	info;		/* Pointer to Valid camera frame */
char		*data;		/* Pointer to camera data */


/**************GRAPHICS WINDOW VARIABLES*****************/
int n=0;
int point_number=1;
int windimx=640;
int windimy=480;
float sumx=0.0;
float sumy=0.0;
float averagex=0.0;
float averagey=0.0;
float Radius, NewRadius, XCoord, YCoord, NewXCoord, NewYCoord;

int             freeze = 0;
int 		collect = 0;
int		error_tst = 0;
int		xsize, ysize;		/* Screen Dimensions */
long		win;			/* Graphics window ID*/
int		spin = 0;
GLdouble	a1 = 0.0;
GLdouble	a2 = 0.0;
GLdouble	a3 = 0.0;
int		cropXmin, cropXmax, cropYmin, cropYmax;
int ydisp = 0;			/* y displacement of the image*/
int xdisp = 0; 			/* x displacement of the image*/
int scch =0;			/* change in image scale*/
int xpos=0 ;			/* x cursor position*/
int ypos=0 ;			/* y cursor position*/	

				/* Affine x-form array*/
GLdouble        T[16] =  {    1.0,0.0,0.0,0.0, 
			      0.0,1.0,0.0,0.0, 
                              0.0,0.0,1.0,0.0, 
                              0.0,0.0,0.0,1.0}; 



GLdouble		x1=277-320;   /*GET RID OF CONSTANTS!!!!*/
GLdouble		yone=(89-240);

GLdouble		x2=402-320;  /*free air */ 
GLdouble		y2=(130-240);

GLdouble		x3=311-320;   /*1 foot*/
GLdouble		y3=(246-240);


GLdouble		x1p=155-320;
GLdouble		y1p=(354-240);

GLdouble		x2p=296-320;
GLdouble		y2p=(157-240);

GLdouble		x3p=443-320;
GLdouble		y3p=(340-240);



char     	data1[TEXT_SIZE_X * TEXT_SIZE_Y * 4];  /* 4 bytes per pixel */
char     	data2[TEXT_SIZE_X * TEXT_SIZE_Y * 4];  /* 4 bytes per pixel */
char     	dataDelta[TEXT_SIZE_X * TEXT_SIZE_Y * 4];  /* 4 bytes per pixel */

/* data1 is most recent image
   data2 is previous image
   dataDelta = data1 - data2 */

void stephKeyboard(void)
{
    printf("steph's keyboard routine\n");

    /* printf("You are to enter the targets coordinates.\n");
    printf("What X coordinate would you like.  X Coordinate = %f\n", XCoord);
    
    if(XCoord > 12 || XCoord < 0)
    {
       printf("This is not a valid number for the X coordinate.  Please enter a number within the range of 11>X>0.\n  The new X Coordinate = %f\n", NewXCoord);
    }
    printf("What Y coordinate would you like.  Y Coordinate = %f\n", YCoord);
  
    if(YCoord > 12 || YCoord < 0)
    {
       printf("This is not a valid number for the Y Coordinate.  Please enter a number within the range of 11>Y>0.\n The new Y Coordinate = %f\n", NewYCoord);
    }
    printf("You need to enter the radius of the circle.\n");
    printf("What would you like the radius to be?\n Radius = %f\n" Radius);
   
    if(Radius > 12 || Radius < 1)
    {
       printf("This is not a valid number for the radius, Please enter a number between 12 and 1.\n The new Radius = %f\n", NewRadius);
    }
    */
}

void stephRunningLoop(void)
{
    char maxIntensity = 0;
    int x,y;
    int yTimesTEXT_SIZE;

    printf("stephRunningLoop\n");

    for (y=  cropYmin; y < cropYmax; y++)
    {
	yTimesTEXT_SIZE = y*TEXT_SIZE_X;

	for (x = cropXmin; x < cropXmax; x++)
	{
	    if (maxIntensity < data1[(yTimesTEXT_SIZE + x)])
            {
                maxIntensity = data1[(yTimesTEXT_SIZE + x)];
            }
	}
   }   

   printf("stephRunningLoop max = %i\n", (int) maxIntensity);
}

void stephInit(void)
{
    printf("stephInit\n");
}

void
vl_init()
{
    if (!(svr = vlOpenVideo("")))		/* Connect to video daemon */
	exit(0);

    src = vlGetNode(svr, VL_SRC, VL_VIDEO, VL_ANY);	/* open analog node */

    drn = vlGetNode(svr, VL_DRN, VL_MEM, VL_ANY);	/* open memory node */

    path = vlCreatePath(svr, VL_ANY, src, drn);		/* set up paths */

    if ((vlSetupPaths(svr, (VLPathList)&path, 1, VL_SHARE, VL_SHARE)) < 0)
	exit(0);			      	/* set up path to be */
						/* loose */

     val.intVal = VL_PACKING_RGB_8;  		/* 8-bit data */
    /*val.intVal = VL_PACKING_Y_8_IP;*/     /* JUST LUMINANCE? */
    vlSetControl(svr, path, drn, VL_PACKING, &val);

    vlGetControl(svr, path, drn, VL_SIZE, &val);	/* get size of */
                                                        /* frame */
    xsize = val.xyVal.x;
    ysize = val.xyVal.y;
    printf("X %d Y %d\n",xsize, ysize);
    
/*
    cropXmin=0;
    cropXmax=xsize;
    cropYmin=0;
    cropYmax=ysize;
*/  
/*    cropXmin=129;
    cropXmax=661;
    cropYmin=42;
    cropYmax=294;
*/	
	/*cropXmin=0;
    	cropXmax=661;
    	cropYmin=0;
    	cropYmax=294;*/
      cropXmin =198;
      cropXmax =586; 
      cropYmin =50; 
      cropYmax =294;

    buffer = vlCreateBuffer(svr, path, drn, 1);	/* Create data buffer */
    if (buffer == NULL)
	exit(0);
    
    vlRegisterBuffer(svr, path, drn, buffer);	/* Assign buffer to path */

    if (vlBeginTransfer(svr, path, 0, NULL))
	exit(0);
    
    /*stephInit();*/    
}

static void
usage(void)
{
  printf("\n");
  printf("usage: scube [options]\n");
  printf("\n");
  printf("    display a spinning cube and its shadow\n");
  printf("\n");
  printf("  Options:\n");
  printf("    -geometry  window size and location\n");
  printf("    -c         toggle color index mode\n");
  printf("    -l         toggle lighting\n");
  printf("    -f         toggle fog\n");
  printf("    -db        toggle double buffering\n");
  printf("    -logo      toggle sgi logo for the shadow pattern\n");
  printf("    -quads     toggle use of GL_QUADS to draw the checkerboard\n");
  printf("\n");
#ifndef EXIT_FAILURE    /* should be defined by ANSI C
                           <stdlib.h> */
#define EXIT_FAILURE 1
#endif
  exit(EXIT_FAILURE);
}

void		wait_for_frame() {
    long	v[2];
    int		x, y;
    int i = 0;
    int j = 0;
    int yTimesTEXT_SIZE;
    int yTimesXsize;
    
   if(freeze==0)
   {     
       do {
	    /*	sginap(1);*/
	    info = vlGetLatestValid(svr, buffer);
	} while (!info);			/* wait for valid frame */
    
	data = vlGetActiveRegion(svr, buffer, info);	/* get screen */
							    /* data from */
    
							    /* buffer */
    }

    for (y=  cropYmin; y < cropYmax; y++)
    {
	yTimesTEXT_SIZE = y*TEXT_SIZE_X;
	yTimesXsize = y*xsize;

	for (x = cropXmin; x < cropXmax; x++)
	{
	    data1[(yTimesTEXT_SIZE + x)] = data[4*(yTimesXsize +x)+3];
	}
   }    
    
    glColor3d(0.0,0.0,0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    /*glPixelStorei(GL_UNPACK_ALIGNMENT, 1);*/

    /*glTexImage2D(GL_TEXTURE_2D, 0, 4, TEXT_SIZE_X, TEXT_SIZE_Y, 0, GL_ABGR_EXT*/
    glTexImage2D(GL_TEXTURE_2D, 0, 1, TEXT_SIZE_X, TEXT_SIZE_Y, 0, GL_LUMINANCE

,
		 GL_UNSIGNED_BYTE, data1); 

    glColor3d(0.0,0.5,1.0); 

    /*for (i = -1; i < 2; i++)*/
	/*for (j = -1; j < 2; j++)*/{
	    /* glPushMatrix(); */
	    /* if (spin) {*/
		/* glRotated(a1, 1.0, 0.0, 0.0);
		glRotated(a2, 0.0, 0.0, 1.0);
		glRotated(a3, 0.0, 1.0, 0.0);*/
		/*}*/
	    
   glBegin(GL_QUADS);
	    glTexCoord2d(0.0, 0.0);
	    glVertex3d(-xsize/2.0, -ysize/2.0, 0.0);
	    glTexCoord2d((GLdouble)xsize/TEXT_SIZE_X, 0.0);
	    glVertex3d(xsize/2.0, -ysize/2.0, 0.0);
	    glTexCoord2d((GLdouble)xsize/TEXT_SIZE_X, (GLdouble)ysize/TEXT_SIZE_Y);
	    glVertex3d(xsize/2.0, ysize/2.0, 0.0);
	    glTexCoord2d(0.0, (GLdouble)ysize/TEXT_SIZE_Y);
	    glVertex3d(-xsize/2.0, ysize/2.0, 0.0);
    glEnd();

/* Draw Test Box
    glColor4d(1.0,0.0,0.0, 1.0); 

    glBegin(GL_LINE_STRIP);
	    glVertex3d(-xsize/2.0, -ysize/2.0, 0.0);
	    glVertex3d(xsize/2.0, -ysize/2.0, 0.0);
	    glVertex3d(xsize/2.0, ysize/2.0, 0.0);
	    glVertex3d(-xsize/2.0, ysize/2.0, 0.0);
    glEnd();
*/

	    glPopMatrix();
	}
     
    
    
    /*glRasterPos2d(0.0, 0.0);
    
    glDrawPixels(xsize, ysize, GL_ABGR_EXT, GL_UNSIGNED_BYTE, data);*/

    
       /*glDisable(GL_LIGHTING);
       glLoadIdentity();
       glColor4f(0.0, 1.0, 0.0, 1.0);
       glBegin(GL_LINE);
		glVertex3d(1000.0,0.0,0.0); 
		glVertex3d(-1000, 0, 0);
       glEnd();

	glBegin(GL_TRIANGLES);                                         
                glVertex3f( 0.0f, 100.0f, 0.0f);                         
                glVertex3f(-100.0f,-100.0f, 0.0f);                         
                glVertex3f( 100.0f,-100.0f, 0.0f);                         
        glEnd();   */                                                   



/*Create an 8X8 Grid*/
    /*i=0;
    for (i = -2; i < 3; i++) {
    	glBegin(GL_LINES);
		glColor3d(0.0,1.0,0.0); 
		glVertex3d(-2, i, 0);
		glVertex3d(2, i, 0);
		glVertex3d(-2, i+.5, 0);
		glVertex3d(2, i+.5, 0);
		glVertex3d(i, -2, 0);
		glVertex3d(i, 2, 0);
		glVertex3d(i+.5, 2, 0);
		glVertex3d(i+.5, -2, 0);
    	glEnd();  
    }*/




/*      RGBcolor(255,0,0);  */
/*      bgnline();  */
/*      v[0] = v[1] = 0; v2i(v);  */
/*      v[0] = xsize-1, v[1] = ysize-1; v2i(v);  */
/*      endline();  */
    
    /*stephRunningLoop();*/
    /*glFlush();*/
    /*glutPostRedisplay();*/
    
    /*glFlush();*/
    glutSwapBuffers();
    
    
    vlPutFree(svr, buffer);		/* frame is ready for use again */
}

void
idle(void)
{
     wait_for_frame();
}

void
mouse(int button, int state, int x, int y)
{
	int number_points=4;
	
	if ((button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN) && (collect == 1)&& (point_number != 7))
	{
	   xpos=x;
	   ypos=ysize-y;
	   
       	   printf("%i\n",n+1);
           printf("x position = %i\n", xpos);
	   printf("y position = %i\n", ypos);
      	   
           fprintf(fpt1,"%3i %3i\n",xpos, ypos);
           n=n+1;
	   
	   sumx=sumx+xpos;
	   sumy=sumy+ypos;

	   if (n==number_points)
	   {
		averagex=sumx/number_points;
		averagey=sumy/number_points;
		fprintf(fpt1,"\naverage %3.3f %3.3f\n",averagex, averagey);
		fprintf(fpt2,"%3.3f %3.3f\n",averagex, averagey);
		printf("collection complete\n");
	   	
		if (point_number == 1)
		{
			x1=averagex-(windimx/2);
			yone=averagey-(windimy/2);
		}

		if (point_number == 2)
		{
			x2=averagex-(windimx/2);
			y2=averagey-(windimy/2);
		}

		if (point_number == 3)
		{
			x3=averagex-(windimx/2);
			y3=averagey-(windimy/2);
		}

		if (point_number == 4)
		{
			x1p=averagex-(windimx/2);
			y1p=averagey-(windimy/2);
		}

		if (point_number == 5)
		{
			x2p=averagex-(windimx/2);
			y2p=averagey-(windimy/2);
		}

		if (point_number == 6)
		{
			x3p=averagex-(windimx/2);
			y3p=averagey-(windimy/2);

			fclose(fpt1);
			fclose(fpt2); 
			
			printf("YOUR ARE NOW READY TO PERFOM THE AFFINE TRANSFORM\n");
			printf("press b to perform the affine transform");
		}

		n=0;
		collect=0;
		sumx=0;
		sumy=0;
		xpos=0;
	   	ypos=0;
		point_number=point_number+1;
	   } 

	}

	
		if ((button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN) && (error_tst == 1))
		{
	   		xpos=x;
	   		ypos=ysize-y;
	   
           		printf("x position = %i\n", xpos);
	   		printf("y position = %i\n", ypos);

			fprintf(fpt4,"Point: %3i %3i\n",xpos, ypos);

			printf("\ndetermine necessary x and y displacement to align point\n");
      	   	

		}

	
}

void
keyboard(unsigned char ch, int x, int y)
{
    int cropChange = 3;
    int i;
    int j;
    char point_name[10];
    
    /*rotate 90 degrees */

    if (ch == 'F')
       freeze = 1;

    if (ch == 'R')
	glRotated(90.0, 0.0, 0.0, 1.0);
    if (ch == 'r')
	glRotated(1.0, 0.0, 0.0, 1.0);
 
    if (ch == 'm')
	{
		glTranslated(0.0, -1.0, 0.0);
	  	ydisp=ydisp-1;

  	}   
    if (ch == 'M')
	{
		glTranslated(0.0, -10.0, 0.0);
	  	ydisp=ydisp-1;

  	}   
    if (ch == 'i')
	{
		glTranslated(0.0, 1.0, 0.0);
	  	ydisp=ydisp+1;

  	}   
    if (ch == 'I')
	{
		glTranslated(0.0, 10.0, 0.0);
	  	ydisp=ydisp+1;

  	}   
     if (ch == 'k')
	{
		glTranslated(1.0, 0.0, 0.0);
	  	xdisp=xdisp+1;

  	}   
     if (ch == 'K')
	{
		glTranslated(10.0, 0.0, 0.0);
	  	xdisp=xdisp+1;

		
  	}   
     if (ch == 'j')
	{
		glTranslated(-1.0, 0.0, 0.0);
	  	xdisp=xdisp-1;

  	}   
     if (ch == 'J')
	{
		glTranslated(-10.0, 0.0, 0.0);
	  	xdisp=xdisp-1;

  	}   

    if (ch == ',')
	{
		glScaled(1.01, 1.01, 1.01);
		scch=scch+1;

	}
    if (ch == '>')
		glScaled(1.1, 1.1, 1.1);

    if (ch == '.')
	{
		glScaled(0.99, 0.99, 0.99);
		scch=scch-1;

	}
    if (ch == '<')
		glScaled(0.9, 0.9, 0.9);

	
    if (ch == 'a')
    {
       cropXmin += cropChange;
       if(cropXmin > xsize) cropXmin = xsize;
    }

    if (ch == 'z')
    {
       cropXmin -= cropChange;
       if(cropXmin < 0) cropXmin = 0;
    }

    if (ch == 'x')
    {
       cropXmax += cropChange;
       if(cropXmax > xsize) cropXmax = xsize;
    }

    if (ch == 's')
    {
       cropXmax -= cropChange;
       if(cropXmax < 0) cropXmax = 0;
    }

    if (ch == 'd')
    {
       cropYmin += cropChange;
       if(cropYmin > ysize) cropYmin = ysize;
    }

    if (ch == 'c')
    {
       cropYmin -= cropChange;
       if(cropYmin < 0) cropYmin = 0;
    }

    if (ch == 'f')
    {
       cropYmax += cropChange;
       if(cropYmax > ysize) cropYmax = ysize;
    }

    if (ch == 'v')
    {
       cropYmax -= cropChange;
       if(cropYmax < 0) cropYmax = 0;
    }

    if (ch == 'Q')
    {

	glLoadMatrixd(T);
        /*cropXmin=129;
    	cropXmax=661;
    	cropYmin=42;
    	cropYmax=294;*/

	cropXmin=0;
    	cropXmax=661;
    	cropYmin=0;
    	cropYmax=294;
        
    }

    if (ch=='b')
	{


		T[0]=((x3p*(yone-y2))+(x1p*(y2-y3))+(x2p*(-yone+y3)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		T[1]=((y1p*(y2-y3))+(y2p*(-yone+y3))+(y3p*(yone-y2)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		T[4]=((x2p*(x1-x3))+(x1p*(-x2+x3))+(x3p*(-x1+x2)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		T[5]=((y1p*(-x2+x3))+(y2p*(x1-x3))+(y3p*(-x1+x2)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		T[12]=((x3p*(-x2*yone+x1*y2))+(x2p*(x3*yone-x1*y3))+(x1p*(-x3*y2+x2*y3)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		T[13]=((y2p*(x3*yone-x1*y3))+(y1p*(-x3*y2+x2*y3))+(y3p*(-x2*yone+x1*y2)))/(-x2*yone+x3*yone+x1*y2-x3*y2-x1*y3+x2*y3);

		glLoadMatrixd(T);


		for (j = 0; j < 4; j++) 
		{
			for (i = 0; i<4; i++)
			{
				printf ("%lf	", T[j+i*4]);
	   		}
			printf ("\n");	
	    
	    
		}

		xdisp=0;
		ydisp=0;
		
		 
		
	}
    
    if (ch == 'T')
    {

	collect = 1;
        
        printf("Input the name of the point -> ");
        scanf("%s",&point_name);
	fprintf(fpt1,"\n%s\n",point_name);
    
         
        
    }

    if (ch == 'L')
    {
	printf("Uploading settings...\n");
	if ((fpt3=fopen("settings.dat", "r")) == 0)
		printf("\nERROR - Cannot open the designated file\n");
	else
	{
		
		fpt3=fopen("settings.dat", "r");
		fscanf(fpt3,"%3.3f", &x1);
		printf("%3.3f\n", x1);
		printf("Done.  Press b to activate\n");
		
			
	} 
         
        
    }

    if (ch == 'Y')
    {
	printf("Click on Point\n\n");
	error_tst = 1;

    }

    if (ch == 'C')
    {
	
	printf("delta x = %i   delta y = %i\n\n",xdisp, ydisp);
	fprintf(fpt4,"delta x = %i   delta y = %i\n\n",xdisp, ydisp);

    }

   
    if (ch == '?')
    {
       printf("MENU\n");
       printf("a - left crop     ->		<-   s - right crop\n");
       printf("z - left expand   <-		->   x - right expand\n");
       
       printf("d - top crop			     c - top expand \n");
       printf("v - bottom crop 			     f - bottom expand\n\n");      

       printf("i - translates the +y	k - translates +x\n");
       printf("m - translates the -y	j - translates -x\n\n");
       
       printf("R - rotates the image CCW 90 degrees\n");
       printf("r - rotates the image CCW  1 degrees\n\n");

       printf("Shift-w - display image properties\n");
       printf("Shift-q - return image to default location\n");
	
       printf("F - toggle freeze-frame\n");

       printf("T - start collecting values for a point\n");

       printf("Y - determine error in points\n");

       printf("C - collect error in points\n");      


    }


    if (ch == '1')
    {
      stephKeyboard();
    }

    printf("xdisplace = %i	ydisplace = %i		scale= %i\n", xdisp, ydisp,scch);
    printf("Left Crop = %i 	Rigth Crop = %i    Bottom Crop= %i 	Top Crop = %i \n", 
    cropXmin, cropXmax, cropYmin, cropYmax);
   
    for(i=0; i<TEXT_SIZE_X*TEXT_SIZE_Y*4; ++i) data1[i]=0;
}

void		close_video() {
    vlEndTransfer(svr, path);
    vlDeregisterBuffer(svr, path, drn, buffer);
    vlDestroyBuffer(svr, buffer);
    vlDestroyPath(svr, path);
    vlCloseVideo(svr);
}

void
display(void)
{
    glutSwapBuffers();

}

void
menu_select(int mode)
{
  switch (mode) {
  case 1: 
      /*glLoadIdentity();
      glRotated(180.0, 1.0, 0.0, 0.0);
      glTranslated(-68.0, 0.0, 0.0);
      glTranslated(0.0, -3.0, 0.0);*/
      
      glLoadIdentity();
      glRotated(180.0, 1.0, 0.0, 0.0);
      glTranslated(-68.0, 0.0, 0.0);
      glTranslated(0.0, 6.0, 0.0);
      glScaled(0.99, 0.99, 0.99);
      glScaled(0.99, 0.99, 0.99);
      glScaled(0.99, 0.99, 0.99);
      	
      
      cropXmin =198;
      cropXmax =586; 
      cropYmin =45; 
      cropYmax =294;
      
      spin = 0;
      a1 = a2 = a3 = 0.0;
      system("killall playaifc &");
      
      break;
  case 2: 
      spin = !spin;
      if (spin)
	  system("playaifc /usr0/ajl/data/danube.aifc &");
      else
	  system("killall playaifc &");
      
      break;

  case 666:
      close_video();
      system("killall playaifc &");
      exit(0);
      break;
  }
}

int
main(int argc, char **argv)
{
  int menu;

  fpt1 = fopen("data.dat","w");
  /*fpt2 = fopen("settings.dat","w");*/
  
  fpt4 = fopen("error.dat","w");

  system("videoout -nocontrol -geometry +6+33");

  vl_init();
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(xsize, ysize);
  
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  win = glutCreateWindow("Sonic Flashlight(TM)");

  glutKeyboardFunc(keyboard);
  glutMouseFunc(mouse);
  glutDisplayFunc(wait_for_frame);
  glutIdleFunc(idle);
  
  menu = glutCreateMenu(menu_select);
  glutAddMenuEntry("Reset", 1);
  glutAddMenuEntry("Toggle Spin", 2);
  glutAddMenuEntry("Quit", 666);
  glutAttachMenu(GLUT_RIGHT_BUTTON);


  /* setup context */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  /*glOrtho(0.0, (GLdouble)512, 0.0, (GLdouble)256, -1.0, 1.0);*/
  /*glFrustum(-2.0, 2.0, -2.0, 2.0, 10.0, 30.0);*/
  /*glFrustum(-xsize/2.0, xsize/2.0, -ysize/2.0, ysize/2.0, 10.0, 30.0);*/
  glOrtho(-xsize/2.0, xsize/2.0, -ysize/2.0, ysize/2.0, -10.0, 10.0);
  /*glTranslated(0.0, 0.0, -20.0);*/



  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
        GL_NEAREST);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, 
        GL_NEAREST);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE_EXT);
    glEnable(GL_TEXTURE_2D);
    glShadeModel(GL_FLAT);

  
  glClearColor(0.0, 0.0, 0.0, 1);
  glClearIndex(0);
  glClearDepth(1);

  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}

